<template>
  <div id="content-wrap">
    <div class="actions">
      <div id="buttons">
        <button id="new"
        v-on:click="$emit('change-component', 'User'); $emit('object',0)">
          Create New
        </button>
      </div>
    </div>
    <div class="table-wrap">
      <table class="tab">
        <thead>
          <tr>
            <th>username</th>
            <th>Name and Last name</th>
            <th>email</th>
            <th>telephone</th>
            <th>authentication</th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="user in users" v-bind:key="user.id" v-bind:item="user">
            <td>{{user.userName}}</td>
            <td>{{user.name}} {{user.lastName}}</td>
            <td>{{user.email}}</td>
            <td>{{user.phone}}</td>
            <td>{{user.auth}}</td>
            <td>
              <button v-on:click="modify(user.id)">Modify</button>
              <button v-on:click="deleteObj(user)">Delete</button>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'Users',
  data() {
    return {
      users: [],
    };
  },
  mounted() {
    this.get();
  },
  methods: {
    get() {
      axios.get('http://localhost:4000/api/users').then(
        (result) => {
          this.users = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    modify(user) {
      this.$emit('change-component', 'User');
      this.$emit('object', user);
      console.log(user);
    },
    deleteObj(user) {
      const url = `http://localhost:4000/api/users/${user.id}`;
      axios.delete(url).then(
        (result) => {
          if (result) { this.get(); }
        },
      ).catch((error) => {
        console.log(error);
      });
    },
  },
};
</script>

<style scoped>
@import "../CSS/Managment.css";
</style>
